/// <reference types="node" />
import { PathLike } from 'fs';
import { Idl } from './types';
import { Options } from 'prettier';
export * from './types';
export declare class Solita {
    private readonly idl;
    private readonly formatCode;
    private readonly formatOpts;
    private readonly accountsHaveImplicitDiscriminator;
    constructor(idl: Idl, { formatCode, formatOpts, }?: {
        formatCode?: boolean;
        formatOpts?: Options;
    });
    renderCode(): {
        instructions: Record<string, string>;
        accounts: Record<string, string>;
        types: Record<string, string>;
        errors: string | null;
    };
    renderAndWriteTo(outputDir: PathLike): Promise<void>;
    private writeInstructions;
    private writeAccounts;
    private writeTypes;
    private writeErrors;
}
